/*
 * Copyright (c) 2017-2020. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.snooker.api;

import java.util.Date;

/**
 * Event Entity API Interface.
 *
 * @author Dmitry Samoshin aka gotty
 */
public interface Event extends IdEntity {

    int eventId();

    String name();

    Date startDate();

    Date endDate();

    String sponsor();

    Season season();

    String type();

    int num();

    String venue();

    String city();

    String country();

    String discipline();

    int mainEventId();

    Event mainEvent();

    String sex();

    String ageGroup();

    String url();

    String related();

    String stage();

    String valueType();

    String shortName();

    int worldSnookerId();

    String rankingType();

    int eventPredictionId();

    boolean team();

    int format();

    EventFormat formatType();

    String twitter();

    String twitterUrl();

    String hashTag();

    String hashTagUrl();

    float conversionRate();

    boolean allRoundsAdded();

    String photoUrls();

    int numCompetitors();

    int numUpcoming();

    int numActive();

    int numResults();

    String note();

    String commonNote();

    int defendingChampionId();

    Player defendingChampion();

    int previousEditionId();

    Event previousEdition();

}
