/*
 * Copyright (c) 2017-2020. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.snooker.api;

/**
 * Types of Ranking Entity.
 *
 * @author Dmitry Samoshin aka gotty
 */
public enum RankingType {

    MoneyRankings (2013, Season.CURRENT_YEAR),
    MoneySeedings (2013, Season.CURRENT_YEAR),
    OneYearMoneyRankings (2013, Season.CURRENT_YEAR),

    ProjectedMoneyRankings (2013, Season.CURRENT_YEAR),
    ProjectedMoneySeedings (2013, Season.CURRENT_YEAR),
    ProvOneYearMoneyRankings (2013, Season.CURRENT_YEAR),
    ProjectedEndOfSeasonMoneySeedings (2014, Season.CURRENT_YEAR),
    ProjectedGrandPrixMoneyRankings (2014, Season.CURRENT_YEAR),
    ProjectedPCMoneyRankings (2016, Season.CURRENT_YEAR),
    ProjectedWCMoneySeedings (2017, Season.CURRENT_YEAR),

    PrevMoneyRankings (Season.CURRENT_YEAR - 1, Season.CURRENT_YEAR),
    PrevMoneySeedings (Season.CURRENT_YEAR - 1, Season.CURRENT_YEAR),
    PrevOneYearMoneyRankings (Season.CURRENT_YEAR - 1, Season.CURRENT_YEAR),
    PrevOrderOfMerit (Season.CURRENT_YEAR - 1, Season.CURRENT_YEAR),

    WorldGrandPrix2015Rankings (2014, 2014),
    WorldGrandPrix2016Rankings (2015, 2015),
    WorldGrandPrix2017Rankings (2017, 2018),
    WorldGrandPrix2018Rankings (2018, 2018),

    PC2017Rankings (2017, 2017),
    PC2018Rankings (2018, 2018),

    CombinedOrderofMerit2013 (2013, 2013),
    CombinedOrderOfMerit2014 (2014, 2014),
    CombinedOrderOfMerit2016 (2015, 2015),

    Rankings (2010, 2013),
    Seedings (2010, 2013),
    OneYearRankings (2009, 2013),

    OrderOfMerit (2010, 2015),
    APTC (2012, 2015),
    CombinedOrderofMerit (2013, 2015),

    SeedingsAfterPTC6 (2011, 2011),
    SeedingsAfterPTC12 (2011, 2011),
    SeedingsAfterWelsh2012 (2011, 2011),
    SeedingsAfterWorld2012 (2012, 2012),
    SeedingsAfterUKPTC22012 (2012, 2012),
    SeedingsAfterInternational2012 (2012, 2012),
    ProjectedSeedings (2012, 2012),
    SeedingsAfterWorld2013 (2012, 2012),
    SeedingsAfterEPTC22013 (2013, 2013),
    SeedingsAfterShanghaiMasters2013 (2013, 2013),
    SeedingsAfterInternationalChampionship2013 (2013, 2013),
    SeedingsAfterUKChampionship2013 (2013, 2013),
    SeedingsAfterGermanMasters2014 (2013, 2013),
    SeedingsAfterPTCFinals2014 (2013, 2013),
    SeedingsAfterAustralian2014 (2014, 2014),
    SeedingsAfterShanghai2014 (2014, 2014),
    SeedingsAfterInternationalChampionship2014 (2014, 2014),
    SeedingsAfterUKChampionship2014 (2014, 2014),
    SeedingsAfterAPTC32015 (2014, 2014),
    SeedingsAfterGermanMasters2015 (2014, 2014),
    SeedingsAfterChinaOpen2015 (2014, 2014),
    SeedingsAfterAustralian2015 (2015, 2015),
    SeedingsAfterShanghai2015 (2015, 2015),
    SeedingsAfterInternational2015 (2015, 2015),
    SeedingsAfterUK2015 (2015, 2015),
    SeedingsAfterEPTC52015 (2015, 2015),
    SeedingsAfterGerman2016 (2015, 2015),
    SeedingsAfterChina2016 (2015, 2015),
    SeedingsAfterWorld2016 (2015, 2015),
    SeedingsAfterWorldOpen2016 (2016, 2016),
    SeedingsAfterPHC2016 (2016, 2016),
    SeedingsAfterShanghai2016 (2016, 2016),
    SeedingsAfterInternational2016 (2016, 2016),
    SeedingsAfterUK2016 (2016, 2016),
    SeedingsAfterScottish2016 (2016, 2016),
    SeedingsAfterGerman2017 (2016, 2016),
    SeedingsAfterChina2017 (2016, 2016),
    SeedingsAfterWorld2017 (2017, 2017),
    SeedingsAfterRiga2017 (2017, 2017),
    SeedingsAfterIndian2017 (2017, 2017),
    SeedingsAfterWorldOpen2017 (2017, 2017),
    SeedingsAfterEuropean2017 (2017, 2017),
    SeedingsAfterInternational2017 (2017, 2017),
    SeedingsAfterNIO2017 (2017, 2017),
    SeedingsAfterUK2017 (2017, 2017),
    SeedingsAfterScottish2017 (2017, 2017),
    SeedingsAfterGerman2018 (2017, 2017),
    SeedingsAfterShootOut2018 (2017, 2017),

    OrderOfMeritAfterPTC4 (2011, 2011),
    OrderOfMeritAfterPTC8 (2011, 2011),
    OrderOfMeritAfterPTC12 (2011, 2011),
    OrderOfMeritAfterEPTC12012 (2012, 2012),
    OrderOfMeritAfterEPTC32012 (2012, 2012),
    OrderOfMeritAfterEPTC42012 (2012, 2012),
    OrderOfMeritAfterEPTC12013 (2013, 2013),
    OrderOfMeritAfterEPTC22013 (2013, 2013),
    OrderOfMeritAfterEPTC42013 (2013, 2013),
    OrderOfMeritAfterEPTC52013 (2013, 2013),
    OrderOfMeritAfterEPTC62013 (2013, 2013),
    OrderOfMeritAfterEPTC72013 (2013, 2013),
    OrderOfMeritAfterEPTC82014 (2013, 2013),
    OrderOfMeritAfterEPTC12014 (2014, 2014),
    OrderOfMeritAfterEPTC22014 (2014, 2014),
    OrderOfMeritAfterEPTC32014 (2014, 2014),
    OrderOfMeritAfterEPTC42014 (2014, 2014),
    OrderOfMeritAfterEPTC52014 (2014, 2014),
    OrderOfMeritAfterEPTC12015 (2015, 2015),
    OrderOfMeritAfterEPTC22015 (2015, 2015),
    OrderOfMeritAfterEPTC32015 (2015, 2015),
    OrderOfMeritAfterEPTC42015 (2015, 2015),
    OrderOfMeritAfterEPTC52015 (2015, 2015),

    APTCOrderOfMeritAfterAPTC22012 (2012, 2012),
    APTCOrderOfMeritAfterAPTC12013 (2013, 2013),
    APTCOrderOfMeritAfterAPTC22013 (2013, 2013),
    APTCOrderOfMeritAfterAPTC32013 (2013, 2013),
    APTCOrderOfMeritAfterAPTC12014 (2014, 2014),
    APTCOrderOfMeritAfterAPTC22014 (2014, 2014),
    APTCOrderOfMeritAfterAPTC12015 (2014, 2014);


    private int startYear;
    private int endYear;

    RankingType(int startYear, int endYear) {
        this.startYear = startYear;
        this.endYear = endYear;
    }

    public static RankingType byName(String name) {
        for (RankingType type : RankingType.values()) {
            if (type.name().equals(name))
                return type;
        }
        return null;
    }

    public static RankingType byNameAndYear(String name, int year) {
        for (RankingType type : RankingType.values()) {
            if (type.name().equals(name))
                return type.isCorrectYear(year) ? type : null;
        }
        return null;
    }

    public boolean isCorrectYear(int year) {
        return year >= startYear && year <= endYear;
    }

}
